Project/almacen/almacen/urls.py
from django.contrib import admin
from django.urls import path, re_path,include
from django.conf import settings
from django.views.static import serve
from django.contrib.auth import views as auth_views

urlpatterns = [

    # Password Reset URLs
    path('reset_password/',
     auth_views.PasswordResetView.as_view(template_name="accounts/password_reset.html"),
     name="reset_password"),

    path('reset_password_sent/', 
        auth_views.PasswordResetDoneView.as_view(template_name="accounts/password_reset_sent.html"), 
        name="password_reset_done"),

    path('reset/<uidb64>/<token>/',
     auth_views.PasswordResetConfirmView.as_view(template_name="accounts/password_reset_form.html"), 
     name="password_reset_confirm"),

    path('reset_password_complete/', 
        auth_views.PasswordResetCompleteView.as_view(template_name="accounts/password_reset_done.html"), 
        name="password_reset_complete"),

    # First Urls    
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('',include(('applications.base.urls','base'))),
]

if settings.DEBUG:
    urlpatterns += [
        re_path(r'^media/(?P<path>.*)$', serve ,{
            'document_root':settings.MEDIA_ROOT,
        })
    ]

Project/almacen/applications/base/urls.py
from django.urls import path
# from django.conf.urls import url
from .views import registrar_admin, edit_order, login_admin, index, add_order, list_order, order_reception, AgregarProducto, listar_producto, editar_producto, usuario_logout, add_client, add_debt, list_debt, add_seller, edit_client, edit_debt, add_provider, list_provider, edit_provider, mod_seller, venta_principal, edit_seller, end_sale, listar_venta, editar_venta
from django.contrib.auth import views as auth_views

app_name = 'base'

urlpatterns = [
    path('login/', login_admin, name = 'login'),
    path('registrarcuenta/', registrar_admin, name= 'registrarcuenta'),
    path('logout/', usuario_logout, name = 'logout'),
    path('add_order', add_order, name= 'add_order'),
    path('list_order', list_order, name='list_order'),
    path('edit_order/<int:order_id>', edit_order, name= 'edit'),
    path('reception', order_reception, name='reception'),
    path('agregarproducto/', AgregarProducto.as_view(), name='agregarproducto'),
    path('listarproducto/', listar_producto, name= 'listarproducto'),
    path('editar_producto/<int:product_id>', editar_producto),
    path('add_client', add_client, name='add_client'),
    path('add_debt', add_debt, name='add_debt'),
    path('list_debt', list_debt, name='list_debt'),
    path('agregar-vendedor/', add_seller, name='agregar_vendedor'),
    path('edit_client/<int:client_id>', edit_client, name= 'edit_client'),
    path('edit_debt/<int:debt_id>', edit_debt, name= 'edit_debt'),
    path('add_provider', add_provider, name= 'add_provider'),
    path('list_provider', list_provider, name= 'list_provider'),
    path('edit_provider/<int:provider_id>', edit_provider, name= 'edit_provider'),
    path('modificar-vendedor/', mod_seller, name='modificar-vendedor'),
    path('edit_seller/<int:seller_id>', edit_seller),
    path('venta_principal/', venta_principal, name='ventaprincipal'),
    path('venta_terminada/', end_sale, name='venta_terminada'),
    path('listar_venta/', listar_venta, name= 'listarventa'),
    path('editar_venta/<int:sale_id>', editar_venta),
    path('', index, name='index'),
]

Project/almacen/applications/base/views.py
import datetime
from django.shortcuts import render, redirect
from django.views.generic import ListView, CreateView, UpdateView, DeleteView
from django.contrib.auth import authenticate, login, logout
from django.http import HttpResponseRedirect, HttpResponse
from django.urls import reverse, reverse_lazy
from .forms import AdministratorForm, ProductForm, RegistrarForm, ProductTypeForm, ProviderForm, OrderForm, ClientForm, DebtForm, RegisteredSeller, SaleForm
from .models import Client, Administrator, Product, Provider, Order, Debt, Seller, Product_On_Sale, total_sale, Sale, Product_On_Sale_Completed
from django.contrib.auth.models import User
from django.core.exceptions import ValidationError

def index(request):
    return render(request, 'index.html', {})

def password_reset(request):
    return print("PASS RESET")

def login_admin(request):
        # Recibe formulario mediante metodo POST
    if request.method == 'POST':
        # Recibimos la informacion del formulario
        username = request.POST.get('username')
        password = request.POST.get('password')
        # Autenticamos el usuario
        user = authenticate(username=username, password=password)
        # Verifica que exista el usuario
        if user:
            # Verifica si el usuario esta activo
            if user.is_active:
                # Genera un login para autenticar al usuario
                login(request, user)
                return HttpResponseRedirect(reverse('base:index'))
            else:
                return HttpResponse("Tu cuenta esta inactiva.")
        else:
            # Si no existe usuario
            # print("username: {} - password: {}".format(username, password))
            return HttpResponse("Datos inválidos")
    else:  # Si llega desde una url en metodo GET (desde el navegador)
        return render(request, 'login.html', {})

def usuario_logout(request):
    logout(request)
    return HttpResponseRedirect(reverse('base:index'))

def registrar_admin(request):
    registrado = False
    # Recibe formulario mediante metodo POST
    if request.method == 'POST':
        # Crea formulario de usuario con informacion del request
        user_form = RegistrarForm(data=request.POST)
        # Crea formulario de perfil con informacion del request
        profile_form = AdministratorForm(data=request.POST)
        if user_form.is_valid() and profile_form.is_valid():
            # Guardamos en base de datos
            user = user_form.save()
            # Encripta password con el modelo de django
            user.set_password(user.password)
            # Guarda usuario tras encriptacion
            user.save()
            # Instancia un objeto perfil
            profile = profile_form.save(commit=False)
            # Asigna un usario al perfil
            profile.user = user
            # Guarda en base de datos
            profile.save()
            registrado = True
        else:  # Si alguno de los formularios es invalido
            print(user_form.errors, profile_form.errors)
            return HttpResponse("Datos inválidos")
    else:  # Si no es POST generamos los formularios
        user_form = RegistrarForm()
        profile_form = AdministratorForm
    return render(request, 'administrator_form.html',
                  {'user_form': user_form,
                   'profile_form': profile_form,
                   'registrado': registrado})

def add_seller(request):
    registered = False
    if request.method == 'POST':
        # Crea formulario deL VENDEDOR con informacion del request
        seller_form = RegisteredSeller(data=request.POST)
        # Crea formulario de perfil con informacion del request
        user_form = RegistrarForm(data=request.POST)
        if seller_form.is_valid() and user_form.is_valid():
            # Guardamos en base de datos
            user = user_form.save()
            # Encripta password con el modelo de django
            user.set_password(user.password)
            # Guarda usuario tras encriptacion
            user.save()
            # Instancia un objeto perfil
            profile = seller_form.save(commit=False)
            # Asigna un usario al perfil
            profile.user = user
            # Guarda en base de datos
            profile.save()
            registered = True
        else:  # Si alguno de los formularios es invalido
            print(seller_form.errors, user_form.errors)
            return HttpResponse("Datos invalidos", registered)
    else:  # Si no es POST generamos los formularios
        seller_form = RegisteredSeller()
        user_form = RegistrarForm
    return render(request, 'maintainers/seller/add_seller.html',
                    {
                        'seller_form': seller_form,
                        'user_form': user_form,
                        'registered': registered
                    })

def mod_seller(request):
    # creamos una colección la cual carga TODOS los registos
    sellers = Seller.objects.all().order_by('-id')
    # users = User.objects.all().filter(sellers) 
    return render(request, 'maintainers/seller/mod_seller.html', {'sellers' : sellers})

def edit_seller(request, seller_id):
    # Recuperamos el registro de la base de datos por el id
    instancia = Seller.objects.get(id=seller_id)
    # creamos un formulario con los datos del objeto
    form = RegisteredSeller(instance=instancia)
    # Compronbamos si se envió el formulario
    if request.method == "POST":
        # Actualizamos el formulario con los datos del objeto
        form = RegisteredSeller(request.POST, instance=instancia)
        # Si el formulario es valido....
        if form.is_valid():
            # Guardamos el formulario pero sin confirmar aun
            instancia = form.save(commit=False)
            # grabamos!!!
            instancia.save()

            return redirect('base:modificar-vendedor')
    return render(request, "maintainers/seller/edit_seller.html", {'form': form, 'instancia': instancia})


def list_order(request):
        # creamos una colección la cual carga TODOS los registos
        order = Order.objects.all()
        # renderizamos la colección en el template
        return render(request,
            "list_order.html", {'order': order})

def order_reception(request):
        # creamos una colección la cual carga TODOS los registos
        order = Order.objects.all()
        product_form=ProductForm()
        if request.method== "POST":
            form = ProductForm(request.POST)
            if form.is_valid():
                instancia = form.save(commit=False)
                instancia.save()
                return redirect ('base:reception')
        # renderizamos la colección en el template
        return render(request,
            "order_reception.html", {'order': order, 'product_form': product_form})

def edit_order(request, order_id):
    # Recuperamos el registro de la base de datos por el id
    instancia = Order.objects.get(id=order_id)
    # creamos un formulario con los datos del objeto
    form = OrderForm(instance=instancia)
    # Compronbamos si se envió el formulario
    if request.method == "POST":
        # Actualizamos el formulario con los datos del objeto
        form = OrderForm(request.POST, instance=instancia)
        # Si el formulario es valido....
        if form.is_valid():
            # Guardamos el formulario pero sin confirmar aun
            instancia = form.save(commit=False)
            # grabamos!!!
            instancia.save()
            return redirect('base:list_order')
    return render(request, "edit_order.html", {'form': form, 'instancia': instancia})

def add_order(request):
    # Creamos un formulario vacío
    order_form = OrderForm()
    # Comprobamos si se ha enviado el formulario
    if request.method == "POST":
        # Añadimos los datos recibidos al formulario
        form = OrderForm(request.POST)
        # Si el formulario es válido...
        if form.is_valid():
            # Guardamos el formulario pero sin confirmarlo,
            # así conseguiremos una instancia para manejarla
            instancia = form.save(commit=False)
            # Podemos guardarla cuando queramos
            instancia.save()
            # Después de guardar redireccionamos a la lista
            return redirect('base:add_order')
            

    # Si llegamos al final renderizamos el formulario
    return render(request, "add_order.html", {'order_form': order_form})

def listar_producto(request):
    product = Product.objects.all()
    return render(request,
    "consultar_producto.html", {'product': product})

def editar_producto(request, product_id):
    # Recuperamos el registro de la base de datos por el id
    instancia = Product.objects.get(id=product_id)
    # creamos un formulario con los datos del objeto
    form = ProductForm(instance=instancia)
    # Compronbamos si se envió el formulario
    if request.method == "POST":
        # Actualizamos el formulario con los datos del objeto
        form = ProductForm(request.POST, instance=instancia)
        # Si el formulario es valido....
        if form.is_valid():
            # Guardamos el formulario pero sin confirmar aun
            instancia = form.save(commit=False)
            # grabamos!!!
            instancia.save()
            return redirect('base:listarproducto')
    return render(request, "modificar_producto.html", {'form': form})

class AgregarProducto(CreateView):
    model = Product
    template_name = 'agregar_producto.html'
    form_class = ProductForm
    success_url = '/agregarproducto/'


def add_client(request):
    # Creamos un formulario vacío
    client_form = ClientForm()
    # Comprobamos si se ha enviado el formulario
    if request.method == "POST":
        # Añadimos los datos recibidos al formulario
        form = ClientForm(request.POST)
        # Si el formulario es válido...
        if form.is_valid():
            # Guardamos el formulario pero sin confirmarlo,

Project/almacen/templates/skeleton/base.html
{% load static%}
<!DOCTYPE html>
<html>
  <head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="{% static 'js/bootstrap.js' %}"></script>
    <script src="{% static 'js/base.js' %}"></script>
    <link href="{% static  'css/bootstrap.css' %}" rel="stylesheet" />
    <link href="{% static  'css/fixed_background.css' %}" rel="stylesheet" />
    <link rel="stylesheet" href="{% static 'css/base.css' %}" />
    <link rel="stylesheet" href="{% static 'css/help.css' %}" />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <link
      rel="stylesheet"
      type="text/css"
      href="https://cdn.datatables.net/1.10.21/css/jquery.dataTables.css"
    />

    <script
      type="text/javascript"
      charset="utf8"
      src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.js"
    ></script>

    <script src="https://cdn.datatables.net/buttons/1.6.2/js/dataTables.buttons.min.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.flash.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/pdfmake.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/vfs_fonts.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.html5.min.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.print.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js"></script>
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/fixedheader/3.1.7/js/dataTables.fixedHeader.min.js"></script>
    {% block title %} {% endblock %}
    {% block head %} {% endblock %}
  </head>

  <body>
    {% if not request.user.is_authenticated %}

    <div class="container">
      <h1 class="buttons-title">Debe autenticarse para ver esta página</h1>
      <div class="buttons">
        <a href="{% url 'base:login' %}">
          <button type="button" class="btn btn-primary btn-block">
            Iniciar sesión
          </button></a
        >

        <a href="{% url 'base:registrarcuenta' %}">
          <button type="button" class="btn btn-primary btn-block">
            Registrarse
          </button></a
        >
      </div>
    </div>
    {% block notlogin %}{% endblock %} {% else %}

    <div class="wrapper">
      <nav id="sidebar">
        <div id="wrapper-logo" class="sidebar-brand"></div>
        <ul class="navbar-nav ml-auto">
          {% block manual %} {% endblock %}
          
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:index' %}">Mi Perfil </a>
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:logout' %}">Cerrar sesión </a>
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:ventaprincipal' %}"
              >Realizar una venta</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:listarventa' %}"
              >Listar ventas</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:add_client' %}"
              >Añadir un cliente</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:list_debt' %}"
              >Listar clientes</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:agregar_vendedor' %}"
              >Vendedor</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:agregarproducto' %}"
              >Agregar productos</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:listarproducto' %}"
              >Listar productos</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:add_provider' %}"
              >Añadir proveedor</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:list_provider' %}"
              >Listar proveedores</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:add_order' %}"
              >Añadir orden</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:list_order' %}"
              >Listar ordenes</a
            >
          </li>
          <li class="nav-item mx-1">
            <a class="nav-link" href="{% url 'base:reception' %}"
              >Recepción de productos</a
            >
          </li>

          {% endif %}
        </ul>
      </nav>
      <div class="content">
        {% block content %} {% endblock %}
      </div>
    </div>
  </body>
</html>